<!doctype html>
<html x-data="{ darkMode: localStorage.getItem('dark') === 'true', toggleSidebar: false }" x-init="$watch('darkMode', val => localStorage.setItem('dark', val))" x-bind:class="{ 'dark': darkMode }">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    @vite(['resources/css/app.css'])
    <title>
        {{@$title}}
    </title>
</head>

<body>
    <x-navbar/>
    <div class="flex pt-16 overflow-hidden bg-gray-50 dark:bg-gray-900">
        <x-sidebar  />
       
        <div id="main-content" class="relative w-full h-full overflow-y-auto bg-gray-50 lg:ml-64 dark:bg-gray-900">
            <main class="my-4 px-4">
                {{ $slot }}
            </main>
            <x-footer />
          </div>
       
    </div>
    @vite(['resources/js/app.js'])
    {{@$scripts}}
</body>

</html>
