<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>{{ env('APP_NAME') }}</title>
    @vite(['resources/css/app.css', 'resources/js/app.js'])
</head>

<body class="bg-gray-50 dark:bg-gray-800">

    <div class="min-h-screen bg-gray-100 flex items-center justify-center px-4 sm:px-6 lg:px-8">
        <div class="max-w-4xl w-full space-y-8">
            <h1 class="text-center text-3xl font-extrabold text-[#04009b]">Dashboard Pilkada</h1>
            <div class="bg-white shadow overflow-hidden sm:rounded-lg min-h-96 flex justify-center items-center">
                <div class="grid md:grid-cols-2 gap-8 md:gap-20 p-8 md:p-20 w-full">

                    <div class="space-y-6">
                        <h2 class="text-2xl font-bold text-[#e60002]">Zona</h2>
                        <div class="grid grid-cols-2 gap-4">
                            <a href="https://zona1.isranhadikaltim.id"
                                class="flex flex-col items-center justify-center px-4 py-2 border border-transparent rounded-md shadow-sm text-sm font-medium text-white bg-[#e60002] hover:bg-[#c50002] focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-[#e60002]">
                                Zona 1
                                <small>(Samarinda)</small>
                            </a>
                            <a href="https://zona2.isranhadikaltim.id"
                                class="flex flex-col items-center justify-center px-4 py-2 border border-transparent rounded-md shadow-sm text-sm font-medium text-white bg-[#e60002] hover:bg-[#c50002] focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-[#e60002]">
                                Zona 2
                                <small>(Balikpapan)</small>
                            </a>
                            <a href="https://zona3.isranhadikaltim.id"
                                class="flex flex-col items-center justify-center px-4 py-2 border border-transparent rounded-md shadow-sm text-sm font-medium text-white bg-[#e60002] hover:bg-[#c50002] focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-[#e60002]">
                                Zona 3
                                <small>(Kukar)</small>
                            </a>
                            <a href="https://zona4.isranhadikaltim.id"
                                class="flex flex-col items-center justify-center px-4 py-2 border border-transparent rounded-md shadow-sm text-sm font-medium text-white bg-[#e60002] hover:bg-[#c50002] focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-[#e60002]">
                                Zona 4
                                <small>(Bontang, Berau, Kutim)</small>
                            </a>
                            <a href="https://zona5.isranhadikaltim.id"
                                class="flex flex-col items-center justify-center px-4 py-2 border border-transparent rounded-md shadow-sm text-sm font-medium text-white bg-[#e60002] hover:bg-[#c50002] focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-[#e60002]">
                                Zona 5
                                <small>(PPU, Paser)</small>
                            </a>
                            <a href="https://zona6.isranhadikaltim.id"
                                class="flex flex-col items-center justify-center px-4 py-2 border border-transparent rounded-md shadow-sm text-sm font-medium text-white bg-[#e60002] hover:bg-[#c50002] focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-[#e60002]">
                                Zona 6
                                <small>(Kubar, Mahulu)</small>
                            </a>
                        </div>
                    </div>
                    <div class="space-y-6">
                        <div class="mb-6 text-center">
                            <h2 class="text-xl font-semibold text-gray-700 mb-2">Login</h2>
                            <p class="text-sm text-gray-500">Masuk menggunakan akun terdaftar</p>
                        </div>
                        <form action="{{ route('login.auth') }}" method="POST" class="space-y-6">
                            @csrf
                            @session('error')
                                <div class="mb-4">
                                    <div class="bg-red-100 border border-red-400 text-red-700 px-4 py-3 rounded relative"
                                        role="alert">
                                        <strong class="font-bold">Error!</strong>
                                        <span class="block sm:inline">{{ session('error') }}</span>
                                    </div>
                                </div>
                            @endsession
                            @session('warning')
                                <div class="mb-4">
                                    <div class="bg-yellow-100 border border-yellow-400 text-yellow-700 px-4 py-3 rounded relative"
                                        role="alert">
                                        <strong class="font-bold">Warning!</strong>
                                        <span class="block sm:inline">{{ session('warning') }}</span>
                                    </div>
                                </div>
                            @endsession
                            <div class="space-y-4">
                                <div class="relative">
                                    <input type="number" maxlength="20" required name="no_hp"
                                        class="w-full px-4 py-2 border rounded-md focus:outline-none focus:ring-1 focus:ring-blue-600 pl-10"
                                        placeholder="No. HP">
                                    <svg xmlns="http://www.w3.org/2000/svg"
                                        class="h-5 w-5 absolute left-3 top-2.5 text-gray-400" viewBox="0 0 20 20"
                                        fill="currentColor">
                                        <path fill-rule="evenodd" d="M10 9a3 3 0 100-6 3 3 0 000 6zm-7 9a7 7 0 1114 0H3z"
                                            clip-rule="evenodd" />
                                    </svg>
                                </div>
                                @error('no_hp')
                                    <span class="text-red-500 text-xs mt-1">{{ $message }}</span>
                                @enderror
        
                                <div class="relative">
                                    <input type="password" name="password" value="" required
                                        class="w-full px-4 py-2 border rounded-md focus:outline-none focus:ring-1 focus:ring-blue-600 pl-10"
                                        placeholder="Password">
                                    <svg xmlns="http://www.w3.org/2000/svg"
                                        class="h-5 w-5 absolute left-3 top-2.5 text-gray-400" viewBox="0 0 20 20"
                                        fill="currentColor">
                                        <path fill-rule="evenodd"
                                            d="M5 9V7a5 5 0 0110 0v2a2 2 0 012 2v5a2 2 0 01-2 2H5a2 2 0 01-2-2v-5a2 2 0 012-2zm8-2v2H7V7a3 3 0 016 0z"
                                            clip-rule="evenodd" />
                                    </svg>
                                </div>
                                @error('password')
                                    <span class="text-red-500 text-xs mt-1">{{ $message }}</span>
                                @enderror
                            </div>
        
                            {{-- <div class="text-right">
                                <a href="#" class="text-sm text-blue-600 hover:underline">Forgot password?</a>
                            </div> --}}
        
                            <button type="submit"
                                class="w-full bg-blueTheme text-white py-2 px-4 rounded-md hover:bg-blue-900 transition duration-300">
                                Login
                            </button>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
</body>

</html>
